#include "tunnel.h"



#define RELHDR_ID	0	/* 1 */
#define RELHDR_RID	1	/* 1 */
#define RELHDR_FLAGS	2	/* 1 */
#define RELHDR_SEQ	3	/* 4 */
#define RELHDR_HDRCKSUM	7	/* 2 */
#define RELHDR_DATALEN	9	/* 1 */
#define RELHDR_DATACKSUM 10	/* 2 */
#define RELHDR_DATA 12		/*___*/
#define RELHDR_LEN	12      /* 12 bytes */


#define PSH	0x1 
#define	RSD	0x2
#define	FIN	0x4
#define RST	0x8
#define	SYN	0x10
#define ACK	0x40


#define SEQ_INCR   	1
#define SEQ_BEGIN       1 

#define SEND_TIMEOUT	5 	/* seconds, this should probably be msecs later */
#define SEND_RETRIES	5	/* max numbers of retries before we give up */

				/* after (SEND_TIMEOUT * SEND_RETRIES) seconds a
				 * dead link will be disconnected
				 */

#define MAX_PACKETS_INQ	10 	/* we really just need 1 right now, but for future
				 * enhancements, this might be a good idea */

struct relhdr {
   u_int8_t	id ;		/* 1 */
   u_int8_t	rid ;		/* 1 */
   u_int8_t	flags ;		/* 1 */
   u_int32_t	seq ;		/* 4 */
   u_int16_t	hdr_cksum ;	/* 2 */
   u_int8_t	data_len ;	/* 1 */
   u_int16_t	data_cksum ;	/* 2 */
} __attribute__ ((packed)) ;			       
				

struct packetlog {
   long send_time ;  /* when we sent this */
   u_char *packet ; /* the entire packet */
   int packet_len ; /* and the length of it */
   int resends ;    /* number of resends */
   int flags ; 	    /* i dunno */
} ; 


extern struct packetlog	sendlog[MAX_PACKETS_INQ] ;
extern struct packetlog	recvlog[MAX_PACKETS_INQ] ;

/* extern u_int32_t curr_SEQ ; */

extern int build_packet (const u_int8_t id, const u_int8_t rid, 
			 const u_int8_t flags,
		         const u_int32_t seq, const u_int8_t datalen,
		         const u_char *data, struct relhdr *rhdr,
		         u_char *packet) ;

extern int explode_packet (const u_char *packet, const int packet_len,
			   struct relhdr *pkthdr, u_char *data) ;

extern int __rel__ok_to_send (long seq) ;


struct {
      struct sockaddr tunnel_host_addr ;
      struct sockaddr peer_host_addr ;
      int tunnel_port ;
      int peer_port ;
      char *tunnel_host ;
      char *peer_host ;
      int tunnel_prot ;
      int peer_prot ;
      int tunnel_mode ;
      int peer_mode ;
   
      int8_t id ;
      int8_t rid ;
} conf ;
